<?php

namespace Drupal\purl\Event;

use Drupal\purl\Plugin\MethodPluginManager;
use Drupal\purl\Plugin\ProviderManager;
use Drupal\purl\Plugin\ModifierIndex;
use Drupal\purl\Plugin\Purl\Method\RequestAlteringInterface;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpKernel\Event\RequestEvent;
use Symfony\Component\HttpKernel\KernelEvents;

class RebuildIndex implements EventSubscriberInterface
{
  /**
   * @var ModifierIndex
   */
  protected $modifierIndex;

  /**
   * RebuildIndex constructor.
   * @param ModifierIndex $modifierIndex
   */
  public function __construct(ModifierIndex $modifierIndex)
  {
    $this->modifierIndex = $modifierIndex;
  }

  public static function getSubscribedEvents()
  {
    return array(
      // RequestSubscriber comes in at 50. We need to go before it.
      KernelEvents::REQUEST => array('onRequest', 51),
    );
  }

  public function onRequest(RequestEvent $event, $eventName, EventDispatcherInterface $dispatcher)
  {
    return;
    $this->modifierIndex->performDueRebuilds();
  }
}
